#ifndef _CMD_H_
#define _CMD_H_

#define USE_PIPE_COMM	1

/**/
#define	S_RATE_1st				0
#define	S_RATE_last				6
/**/
#define	BEEP_UP_ON				0
#define	BEEP_UP_OFF				1
#define	BEEP_DOWN_ON			2
#define	BEEP_DOWN_OFF			3
/**/
#define	B_BEEP_UP_ON			0
#define	B_BEEP_DOWN_ON			1

/* Merged from Metrolink tree for XINPUT stuff  */
#ifndef TS_Raw
#define TS_Raw                                  57
#define TS_Scaled                               58
#define SendCoreEvents                  59
#define DontSendCoreEvents              60
#endif
/* End of merged section        */

#if !defined(USE_PIPE_COMM)

/* OLD type */
#define	SELCT_CMD_start		0xa0
#define	SELCT_CMD			SELCT_CMD_start
#define	SELCT_LEFT_CMD		(SELCT_CMD_start+0)
#define	SELCT_MID_CMD		(SELCT_CMD_start+1)
#define	SELCT_RIGHT_CMD		(SELCT_CMD_start+2)
#define	GET_SELCT_LEFT_CMD	(SELCT_CMD_start+3)
#define	GET_SELCT_MID_CMD	(SELCT_CMD_start+4)
#define	GET_SELCT_RIGHT_CMD	(SELCT_CMD_start+5)
#define	SELCT_CMD_end		(SELCT_CMD_start+5)
#define	S_RATE_CMD			0xB0	/* S_RATE_CMD+n : n=d2-d0 bit=rate */
#define	S_RATE_MASK			0x07
#define	BEEP_ON_UP_CMD		0xB8
#define	BEEP_OFF_UP_CMD		0xB9
#define	BEEP_ON_DOWN_CMD	0xBA
#define	BEEP_OFF_DOWN_CMD	0xBB
#define	RESET_CMD			0xBC
// c0-c8 ,d0-df,cd,ce,cf
#define	CALIB_CMD_RANGE_S	0xc0
#define	CALIB_CMD_RANGE_E	0xdf
#define	CALIB_MASK			0x0f
#define CALIB_ADJ_DAT_CMD   0xc0    /* CALIB_ADJ_DAT_CMD+n : n=d3-d0 bit=calib point */
#define CALIB_1_DAT         0xd0    /* CALIB_1_DAT+n : n=d3-d0 bit=calib data(nibble) */
#define CALIB_PRE_FIRST_CMD 0xca
#define CALIB_FIRST_CMD     0xcb
#define CALIB_NEXT_CMD      0xcc
#define CALIB_END_CMD       0xcd
#define CALIB_OK_CMD        0xce
#define CALIB_CANCEL_CMD    0xcf

#else /*USE_PIPE_COMM*/

/* NEW type */
#define	XDEV_KICK			0xc0

#define	DMC_PIPE_RX_FILE	"/tmp/dmc_pipe_rx"	/* write to driver */
#define	DMC_PIPE_TX_FILE	"/tmp/dmc_pipe_tx"	/* write to app */

#define	SET_RATE_CMD		0x0001	/* dat = 0-5  : bit rate 0x30-0x35	*/
									/* res = -1/0 : error/success 		*/
#define	GET_RATE_CMD		0x0002	/* dat = no use                     */
									/* res = 0-5  : bit rate 0x30-0x35	*/
#define	SET_BEEP_CMD		0x0003	/* dat = 0-3  : BEEP_xx_xx define	*/
									/* res = -1/0 : error/success 		*/
#define	GET_BEEP_CMD		0x0004	/* dat = no use                     */
									/* res = bit0/1 : B_BEEP_xx_ON      */
#define	RESET_CMD			0x0005	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define	SET_SELECTOR_CMD	0x0006	/* dat = 0-2 : SELECT_xx define		*/
# define	SELECT_LEFT			0
# define	SELECT_MID			1
# define	SELECT_RIGHT		2
									/* res = -1/0 : error/success 		*/
#define	GET_SELECTOR_CMD	0x0007	/* dat = none 						*/ 
									/* res = 0-2 :						*/
#define	SAVE_CMD			0x0008	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define	GET_CALIBNUM_CMD	0x0009	/* dat = none 						*/ 
									/* res = 2-9 :						*/
#define	GET_INFO_CMD		0x000A	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define CALIB_FIRST_CMD     0x0030	/* dat = x,y data					*/
									/* res = -1/0 : error/success 		*/
#define CALIB_NEXT_CMD      0x0031	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define CALIB_END_CMD       0x0032	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define CALIB_OK_CMD        0x0033	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define CALIB_CANCEL_CMD    0x0034	/* dat = no use						*/
									/* res = -1/0 : error/success 		*/
#define SET_MEM			    0x0035	/* dat = addr,dat					*/
									/* res = -1/0 : error/success 		*/
#define GET_MEM			    0x0036	/* dat = addr						*/
									/* res = 0-0xffff					*/
#define SET_OFFDELAY	    0x0037	/* dat = delay(msec)				*/
									/* res = 0-0xffff					*/
#define GET_OFFDELAY	    0x0038	/* dat = no use						*/
									/* res = 0-0xffff					*/
typedef struct uApRect
{
	short x,y;
	unsigned short width,height;
} uApRect;

typedef struct dmc_pkheader
{
	short cmd;
	short rsv;
} dmc_pktheader;

typedef struct dmc_pktres
{
	dmc_pktheader hd;
	int res;
} dmc_pktres;

typedef struct dmc_pktresinfo
{
	dmc_pktheader hd;
	int res;
	int screen_num;
	int max_x;
	int max_y;
	u_short beep;		/* 0-3:beep */
	u_short rate;		/* 0-5:rate */
	u_short select;		/* 0-2:select button */
	int offdelay;
	short eeprom_read_ok;
	short calib_point;
} dmc_pktresinfo;

typedef struct dmc_pktnorm
{
	dmc_pktheader hd;
	u_short dat;
} dmc_pktnorm;

typedef struct dmc_pktcalib
{
	dmc_pktheader hd;
	short calib_point;
	uApRect adj[16];
} dmc_pktcalib;

typedef struct dmc_pktrwmem
{
	dmc_pktheader hd;
	u_short addr;
	u_short dat;
} dmc_pktrwmem;

typedef struct dmc_pkt
{
	union
	{
		dmc_pktres pres;
		dmc_pktnorm pnorm;
		dmc_pktcalib pcalib;
		dmc_pktrwmem rwmem;
	} u;
} dmc_pkt;

#endif /*USE_PIPE_COMM*/

#endif /*_CMD_H_*/

